about summary refs log tree commit homepage
path: root/script/public-inbox-mda
diff options
context:
space:
mode:
Diffstat (limited to 'script/public-inbox-mda')
-rwxr-xr-xscript/public-inbox-mda63
1 files changed, 41 insertions, 22 deletions
diff --git a/script/public-inbox-mda b/script/public-inbox-mda
index f37c7492..b463b07b 100755
--- a/script/public-inbox-mda
+++ b/script/public-inbox-mda
@@ -1,13 +1,29 @@
 #!/usr/bin/perl -w
-# Copyright (C) 2013-2020 all contributors <meta@public-inbox.org>
+# Copyright (C) all contributors <meta@public-inbox.org>
 # License: AGPL-3.0+ <https://www.gnu.org/licenses/agpl-3.0.txt>
 #
 # Mail delivery agent for public-inbox, run from your MTA upon mail delivery
+my $help = <<EOF;
+usage: public-inbox-mda [OPTIONS] </path/to/RFC2822_message
+
+options:
+
+  --no-precheck  skip internal checks for spam messages
+
+See public-inbox-mda(1) man page for full documentation.
+EOF
 use strict;
-use warnings;
-my $usage = 'public-inbox-mda [OPTIONS] < rfc2822_message';
-my $precheck = grep(/\A--no-precheck\z/, @ARGV) ? 0 : 1;
-my ($ems, $emm);
+use Getopt::Long qw(:config gnu_getopt no_ignore_case auto_abbrev);
+my ($ems, $emm, $show_help);
+my $precheck = 1;
+use PublicInbox::Import;
+local $PublicInbox::Import::DROP_UNIQUE_UNSUB; # does this need a CLI switch?
+GetOptions('precheck!' => \$precheck, 'help|h' => \$show_help) or
+        do { print STDERR $help; exit 1 };
+if ($show_help) {
+        print $help;
+        exit;
+}
 
 my $do_exit = sub {
         my ($code) = shift;
@@ -15,8 +31,7 @@ my $do_exit = sub {
         exit $code;
 };
 
-use Email::Simple;
-use PublicInbox::MIME;
+use PublicInbox::Eml;
 use PublicInbox::MDA;
 use PublicInbox::Config;
 use PublicInbox::Emergency;
@@ -24,29 +39,32 @@ use PublicInbox::Filter::Base;
 use PublicInbox::InboxWritable;
 use PublicInbox::Spamcheck;
 
-# n.b: hopefully we can setup the emergency path without bailing due to
-# user error, we really want to setup the emergency destination ASAP
+# n.b.: Hopefully we can set up the emergency path without bailing due to
+# user error, we really want to set up the emergency destination ASAP
 # in case there's bugs in our code or user error.
 my $emergency = $ENV{PI_EMERGENCY} || "$ENV{HOME}/.public-inbox/emergency/";
 $ems = PublicInbox::Emergency->new($emergency);
-my $str = eval { local $/; <STDIN> };
-$str =~ s/\A[\r\n]*From [^\r\n]*\r?\n//s;
+my $str = PublicInbox::IO::read_all \*STDIN;
+PublicInbox::Eml::strip_from($str);
 $ems->prepare(\$str);
-my $simple = Email::Simple->new(\$str);
-my $config = PublicInbox::Config->new;
+my $eml = PublicInbox::Eml->new(\$str);
+my $cfg = PublicInbox::Config->new;
 my $key = 'publicinboxmda.spamcheck';
 my $default = 'PublicInbox::Spamcheck::Spamc';
-my $spamc = PublicInbox::Spamcheck::get($config, $key, $default);
+my $spamc = PublicInbox::Spamcheck::get($cfg, $key, $default);
 my $dests = [];
+PublicInbox::Import::load_config($cfg, $do_exit);
+
 my $recipient = $ENV{ORIGINAL_RECIPIENT};
 if (defined $recipient) {
-        my $ibx = $config->lookup($recipient); # first check
+        my $ibx = $cfg->lookup($recipient); # first check
         push @$dests, $ibx if $ibx;
 }
 if (!scalar(@$dests)) {
-        $dests = PublicInbox::MDA->inboxes_for_list_id($config, $simple);
+        $dests = PublicInbox::MDA->inboxes_for_list_id($cfg, $eml);
         if (!scalar(@$dests) && !defined($recipient)) {
-                die "ORIGINAL_RECIPIENT not defined in ENV\n";
+                warn "ORIGINAL_RECIPIENT not defined in ENV\n";
+                $do_exit->(67); # EX_NOUSER
         }
         scalar(@$dests) or $do_exit->(67); # EX_NOUSER 5.1.1 user unknown
 }
@@ -61,7 +79,7 @@ my $err;
                 0;
         # pre-check, MDA has stricter rules than an importer might;
         } elsif ($precheck) {
-                !!PublicInbox::MDA->precheck($simple, $ibx->{address});
+                !!PublicInbox::MDA->precheck($eml, $ibx->{address});
         } else {
                 1;
         }
@@ -69,7 +87,7 @@ my $err;
 
 $do_exit->(67) if $err && scalar(@$dests) == 0;
 
-$simple = undef;
+$eml = undef;
 my $spam_ok;
 if ($spamc) {
         $str = '';
@@ -101,9 +119,10 @@ my @rejects;
 for my $ibx (@$dests) {
         mda_filter_adjust($ibx);
         my $filter = $ibx->filter;
-        my $mime = PublicInbox::MIME->new($str);
+        my $mime = PublicInbox::Eml->new($str);
         my $ret = $filter->delivery($mime);
-        if (ref($ret) && $ret->isa('Email::MIME')) { # filter altered message
+        if (ref($ret) && ($ret->isa('PublicInbox::Eml') ||
+                        $ret->isa('Email::MIME'))) { # filter altered message
                 $mime = $ret;
         } elsif ($ret == PublicInbox::Filter::Base::IGNORE) {
                 next; # nothing, keep looping
@@ -119,7 +138,7 @@ for my $ibx (@$dests) {
                 # destination succeeds
                 $emm->abort;
         } else { # v1-only
-                my $mid = $mime->header_obj->header_raw('Message-ID');
+                my $mid = $mime->header_raw('Message-ID');
                 # this message is similar to what ssoma-mda shows:
                 print STDERR "CONFLICT: Message-ID: $mid exists\n";
         }